#include "lpc2103_.h"
#include <stdio.h>
#include "pict.h"
#include "lcd_n95.h"
#include "serial.h"
 
int main(void)
{
 BYTE rus = 0, shift = 0, x, y;
 BYTE buff[15];
PINSEL0  = 0x00001500;
S0SPCCR = 0x8;
S0SPCR = 0x20;
FIOSET |= LE | SSEL;
FIODIR |= LE | SSEL;
UARTInit(1, 57600, 20000000);
LcdInit();
FillScreen(SKY);
    
/*    SetWindow(0, 95, 0, 124);  //vert,horiz.
    SetAddress(0,0);
     
    for(counter=0; counter<12;counter++)
    {
      for(cnt=0;cnt<1000;cnt++)  
        WrDat(color[counter]);
    }    
    
    
    SetWindow(50, 150, 125, 249);  //vert,horiz.
    SetAddress(125,96);
     
    for(counter=12; counter<25;counter++)
    {
      for(cnt=0;cnt<1000;cnt++)  
        WrDat(color[counter]);
    }  
    SetWindow(0, 239, 0, 319); 
							  
print_str(100, 125, MAROON, SKY, "");
lcd_fillrect(200, 0, 250, 50, NAVY); */

lcd_rect(43, 166, 274, 233, BLACK);
lcd_line(44, 180, 273, 180, DARK_GREY);
lcd_line(44, 193, 273, 193, DARK_GREY);
lcd_line(44, 206, 273, 206, DARK_GREY);
lcd_line(44, 219, 273, 219, DARK_GREY);
Load_image(285, 20, lin);
Load_image(285, 70, win);
Load_image(285, 120, apple);
    
while(1)
{
 if(shift&&(!rus))
 { 
 print_str(45, 168, MAROON, SKY, "~ ! @ # $ % ^ & * ( ) _ + |\0");
 print_str(45, 181, MAROON, SKY, "   Q W E R T Y U I O P { } \0");
 print_str(49, 194, MAROON, SKY, "   A S D F G H J K L : \" ENT\0");
 print_str(49, 207, MAROON, SKY, " SH Z X C V B N M < > ? SH\0");
 print_str(45, 220, MAROON, SKY, "  R/L            DEL\0");
 }

 if((!shift)&&(!rus))
 { 
 print_str(45, 168, MAROON, SKY, "` 1 2 3 4 5 6 7 8 9 0 - = \\\0");
 print_str(45, 181, MAROON, SKY, "   q w e r t y u i o p [ ] \0");
 print_str(49, 194, MAROON, SKY, "   a s d f g h j k l ; ' ENT\0");
 print_str(49, 207, MAROON, SKY, " SH z x c v b n m , . / SH\0");
 print_str(45, 220, MAROON, SKY, "  R/L            DEL\0");
 }

 if(shift&&rus)
 { 
 print_str(45, 168, MAROON, SKY, "~ ! @ # $ % ^ & * ( ) _ + |\0");
 print_str(45, 181, MAROON, SKY, "               \0");
 print_str(49, 194, MAROON, SKY, "              ENT\0");
 print_str(49, 207, MAROON, SKY, " SH          , SH\0");
 print_str(45, 220, MAROON, SKY, "  R/L            DEL\0");
 }

 if((!shift)&&rus)
 { 
 print_str(45, 168, MAROON, SKY, "` 1 2 3 4 5 6 7 8 9 0 - = \\\0");
 print_str(45, 181, MAROON, SKY, "               \0");
 print_str(49, 194, MAROON, SKY, "              ENT\0");
 print_str(49, 207, MAROON, SKY, " SH          . SH\0");
 print_str(45, 220, MAROON, SKY, "  R/L            DEL\0");
 }

 if((x=(Toch_XY()>>9))&&(y=((Toch_XY()&0xff)>>1)))
 {
 switch(y)
  {
   case 18:
   case 19:
   case 20:
  	 {
	  switch(x)
	   {
	   	case 10:
		case 11:
		case 12:
		{
		 if(shift)
		  {sprintf((char*)buff,"~\0");break;}
		 else
		  {sprintf((char*)buff,"`\0");break;}
		}
		case 13:
		case 14:
		{
		 if(shift)
		  {sprintf((char*)buff,"!\0");break;}
		 else
		  {sprintf((char*)buff,"1\0");break;}
		}
		case 16:
		case 17:
		{
		 if(shift)
		  {sprintf((char*)buff,"@\0");break;}
		 else
		  {sprintf((char*)buff,"2\0");break;}
		}
		case 18:
		case 19:
		case 20:
		{
		 if(shift)
		  {sprintf((char*)buff,"#\0");break;}
		 else
		  {sprintf((char*)buff,"3\0");break;}
		}
		case 21:
		case 22:
		case 23:
		{
		 if(shift)
		  {sprintf((char*)buff,"$\0");break;}
		 else
		  {sprintf((char*)buff,"4\0");break;}
		}
		case 24:
		case 25:
		{
		 if(shift)
		  {sprintf((char*)buff,"%%\0");break;}
		 else
		  {sprintf((char*)buff,"5\0");break;}
		}
		case 27:
		case 28:
		{
		 if(shift)
		  {sprintf((char*)buff,"^\0");break;}
		 else
		  {sprintf((char*)buff,"6\0");break;}
		}
		case 30:
		case 31:
		{
		 if(shift)
		  {sprintf((char*)buff,"&\0");break;}
		 else
		  {sprintf((char*)buff,"7\0");break;}
		}
		case 32:
		case 33:
		case 34:
		{
		 if(shift)
		  {sprintf((char*)buff,"*\0");break;}
		 else
		  {sprintf((char*)buff,"8\0");break;}
		}
		case 35:
		case 36:
		{
		 if(shift)
		  {sprintf((char*)buff,"(\0");break;}
		 else
		  {sprintf((char*)buff,"9\0");break;}
		}
		case 38:
		case 39:
		{
		 if(shift)
		  {sprintf((char*)buff,")\0");break;}
		 else
		  {sprintf((char*)buff,"0\0");break;}
		}
		case 41:
		case 42:
		{
		 if(shift)
		  {sprintf((char*)buff,"_\0");break;}
		 else
		  {sprintf((char*)buff,"-\0");break;}
		}
		case 43:
		case 44:
		case 45:
		{
		 if(shift)
		  {sprintf((char*)buff,"+\0");break;}
		 else
		  {sprintf((char*)buff,"=\0");break;}
		}
		case 46:
		case 47:
		case 48:
		{
		 if(shift)
		  {sprintf((char*)buff,"|\0");break;}
		 else
		  {sprintf((char*)buff,"\\\0");break;}
		}
		
	   }
	  break;
	 }
   case 16:
   case 15:
   case 14:
  	 {
	  switch(x)
	   {
	   	
		case 14:
		case 15:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"Q\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"q\0");break;} 
		}
		case 17:
		case 18:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"W\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"w\0");break;}
		}
		case 20:
		case 21:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"E\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"e\0");break;}
		}
		case 23:
		case 24:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"R\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"r\0");break;}
		}
		case 25:
		case 26:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"T\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"t\0");break;}
		}
		case 28:
		case 29:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"Y\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"y\0");break;}
		}
		case 31:
		case 32:
		case 33:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"U\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"u\0");break;}
		}
		case 34:
		case 35:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"I\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"i\0");break;}
		}
		case 36:
		case 37:
		case 38:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"O\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"o\0");break;}
		}
		case 39:
		case 40:
		case 41:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"P\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"p\0");break;}
		}
		case 42:
		case 43:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"{\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"[\0");break;}
		}
		case 45:
		case 46:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"}\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"]\0");break;}
		}
		
	   }
	  break;
	 }
   case 13:
   case 12:
   case 11:
  	 {
	  switch(x)
	   {
	   	
		case 15:
		case 16:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"A\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"a\0");break;}
		}
		case 18:
		case 19:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"S\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"s\0");break;}
		}
		case 20:
		case 21:
		case 22:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"D\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"d\0");break;}
		}
		case 23:
		case 24:
		case 25:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"F\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"f\0");break;}
		}
		case 26:
		case 27:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"G\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"g\0");break;}
		}
		case 29:
		case 30:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"H\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"h\0");break;}
		}
		case 31:
		case 32:
		case 33:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"J\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"j\0");break;}
		}
		case 34:
		case 35:
		case 36:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"K\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"k\0");break;}
		}
		case 37:
		case 38:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"L\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"l\0");break;}
		}
		case 40:
		case 41:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,":\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,";\0");break;}
		}
		case 42:
		case 43:
		case 44:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"\"\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"'\0");break;}
		}
		case 45:
		case 46:
		case 47:
		case 48:
		case 49:
		{
		 sprintf((char*)buff,"\n\0");break;
		}
		
	   }
	  break;
	 }
   case 10:
   case 9:
   case 8:
  	 {
	  switch(x)
	   {
	   	
		case 12:
		case 13:
		case 14:
		case 15:
		{
		 if(shift)
		 { print_str(0, 207, MAROON, SKY, "sh"); shift = 0; break; }
		 else 
		 { print_str(0, 207, BLUE,  SKY, "SH"); shift = 1; break; } 
		}
		case 16:
		case 17:
		case 18:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"Z\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"z\0");break;}
		}
		case 19:
		case 20:
		case 21:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"X\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"x\0");break;}
		}
		case 22:
		case 23:
		case 24:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"C\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"c\0");break;}
		}
		case 25:
		case 26:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"V\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"v\0");break;}
		}
		case 27:
		case 28:
		case 29:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"B\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"b\0");break;}
		}
		case 30:
		case 31:
		case 32:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"N\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"n\0");break;}
		}
		case 33:
		case 34:
		case 35:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"M\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"m\0");break;}
		}
		case 36:
		case 37:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"<\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,",\0");break;}
		}
		case 38:
		case 39:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,"\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,">\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,".\0");break;}
		}
		case 41:
		case 42:
		case 43:
		{
		 if(shift&&rus)
		  {sprintf((char*)buff,",\0");break;}
		 if((!shift)&&rus)
		  {sprintf((char*)buff,".\0");break;}
		 if(shift&&(!rus))
		  {sprintf((char*)buff,"?\0");break;}
		 if((!shift)&&(!rus))
		  {sprintf((char*)buff,"/\0");break;}
		}
		case 44:
		case 45:
		case 46:
		case 47:
		{
		 if(shift)
		 { print_str(0, 207, MAROON, SKY, "sh"); shift = 0; break; }
		 else 
		 { print_str(0, 207, BLUE,  SKY, "SH"); shift = 1; break; } 
		}
		
	   }
	  break;
	 }
   case 6:
   case 5:
   case 4:
  	 {
	  switch(x)
	   {
	   	
		case 13:
		case 14:
		case 15:
		case 16:
		case 17:
		{
		 if(rus)
		 { print_str(0, 220, MAROON, SKY, "lat"); rus = 0; break; }
		 else 
		 { print_str(0, 220, BLUE,  SKY, "rus"); rus = 1; break; } 		 
		}
		case 19:
		case 20:
		case 21:
		case 22:
		case 23:
		case 24:
		case 25:
		case 26:
		case 27:
		case 28:
		case 29:
		case 30:
		case 31:
		case 32:
		case 33:
		case 34:
		case 35:
		case 36:
		case 37:
		case 38:
		case 39:
		case 40:
		{
		 sprintf((char*)buff," \0");break;
		}
		case 42:
		case 43:
		case 44:
		case 45:
		{
		 /*print_str(0, 0, MAROON, SKY, "\n");*/break;
		}
		
	   }
	  break;
	 }
   }
   sendchar (buff[0]);
  }
  print_str(1, 1, MAROON, SKY, buff);
  
 delay_ms(300);
   
}

}
