#include "type.h"

#define    SKY          0x5d1c 
#define    BLACK        0x0000
#define    WHITE        0xFFFF
#define    GREEN        0x07E0
#define    BLUE         0x001F
#define    RED          0xF800
#define    YELLOW       0xffe0 
#define    MAGENTA      0xf81f
#define    CYAN         0x07ff
#define    ORANGE       0xfca0 
#define    PINK         0xF97F
#define    BROWN        0x8200
#define    GREY         0x8410
#define    VIOLET       0x9199
#define    SILVER       0xa510
#define    GOLD         0xa508
#define    BEGH         0xf77b
#define    NAVY			0x000F      
#define    DARK_GREEN	0x03E0      
#define    DARK_CYAN	0x03EF      
#define    MAROON		0x7800      
#define    PURPLE		0x780F      
#define    OLIVE		0x7BE0      
#define    LIGHT_GREY	0xC618      
#define    DARK_GREY	0x7BEF


#define CS   (1<<0)
#define RS   (1<<1)
#define RD   (1<<2)
#define LE   (1<<24)
#define WR   (1<<25)
#define RES  (1<<26)
#define SPIF (1<<7)
#define SSEL (1<<7)
#define SIRQ (1<<3)

void delay_ms(unsigned int ms);
void PortInit(void);
void WrCmd(BYTE cmd);
void WrDat(WORD data);
void SetReg(BYTE index, WORD value);
void LcdInit(void);
void SetAddress(WORD addr1, BYTE addr0);
void FillScreen(WORD color);
void SetWindow(BYTE Hstart, BYTE Hend, WORD Vstart, WORD Vend);
void lcd_pset(WORD x, BYTE y, WORD color);
void Load_image(WORD x1, BYTE y1, const unsigned  char  m[]);
void lcd_circ(short xcenter, char ycenter, char rad, int color);
void lcd_line(short x1,char y1,short x2,char y2,int color);
void lcd_rect(short x, char y, short x1, char y1,int color);
void lcd_fillrect(short x, char y, short x1, char y1,int color);
void print_str(unsigned short x1, unsigned char y1, unsigned short int textcolor, unsigned short int backcolor, unsigned char  txt[]);
WORD Toch_XY(void);
